import finconfig
import fincoretypes
from pyparsing import *

class finIntegerRelationMatcher(object):
  """Matches and integer relation in a script line"""
  _relops={
    '<': finconfig.lt,
    '<=': finconfig.le,
    '>': finconfig.gt,
    '>=': finconfig.ge,
    '==': finconfig.eq,
    '!=': finconfig.ne
  }
  _units={
    '': 1,
    'k': 1000,
    'ki': 1024,
    'M': 1000000,
    'Mi': 1048576,
    'G': 1000000000,
    'Gi': 1073741824
  }
  _bnf=Regex('|'.join(sorted(_relops.keys(), key=len, reverse=True))) + \
    Word('0123456789') + \
    Regex('|'.join(sorted(_units.keys(), key=len, reverse=True)))

  def match(self, input):
    return self._op(input, self._value)

  def parse(self, input, *args):
    spl=self._bnf.parseString(input)
    self._op=self._relops[spl[0]]
    self._value=int(spl[1])*self._units[spl[2]]
