import finconfig
import fincoretypes

class finInput(object):
  """Reads a string from the user"""
  def __init__(self, name, prompt, value=None):
    self.name=name
    self.prompt=prompt
    self.value=value
    
  def get(self):
    """Actually perform the action of getting the input"""
    # TODO: add other forms of input
    v=finconfig.consoleinput(u"%s (%s) [%s]: " % (self.prompt, self.name, self.value))
    if v!='':
      self.value=v.decode('utf-8')

def finInputFactory(name, inputtype, typename, encoding=None):
  """Factory class for generating input classes automagically"""
  class finTypeInput(finInput):
    def __init__(self, *args):
      self.__name__=name
      self.__doc__="""Reads %s from the user""" % typename
      finInput.__init__(self, *args)
    def getvalue(self):
      return self._value
    def delvalue(self):
      del self._value
    def setvalue(self, value):
      if value is None:
        v=None
      else:
        try:
          if encoding is not None:
            v=inputtype(value).decode(encoding)
          else:
            v=inputtype(value)
        except ValueError, e:
          raise ValueError(u'%r is not a(n) %s' % (value, inputtype.__name__))
      self._value=v
    value=property(getvalue, setvalue, delvalue)
  return finTypeInput

finStringInput=finInputFactory('finStringInput', fincoretypes.finString,
  u'a string')
finIntegerInput=finInputFactory('finIntegerInput', fincoretypes.finInteger,
  u'an integer')
finFloatInput=finInputFactory('finFloatInput', fincoretypes.finFloat,
  u'a floating-point number')
