"""This module contains basic functions and constants used throughout
fin"""

import sys
import os.path as path

BASEDIR=path.split(__file__)[0]

sys.path.append(path.join(BASEDIR, 'core'))

encoding=sys.stdout.encoding

def consoleoutput(text):
  """Output a string to the console"""
  sys.stdout.write(text)

def consoleinput(prompt):
  """Output a prompt then read a string from the user"""
  consoleoutput(prompt.encode(encoding, 'replace'))
  return raw_input()

def lt(a, b):
  """Return true if a is less than b"""
  return cmp(a, b)==-1

def le(a, b):
  """Return true if a is less than or equal to b"""
  return cmp(a, b)!=1

def gt(a, b):
  """Return true if a is greater than b"""
  return cmp(a, b)==1

def ge(a, b):
  """Return true if a is greater than or equal to b"""
  return cmp(a, b)!=-1

def eq(a, b):
  """Return true if a is equal to b"""
  return cmp(a, b)==0

def ne(a, b):
  """Return true if a is not equal to b"""
  return cmp(a, b)!=0
