import finconfig
import finsegments
import finoutput
import finmodules
from pyparsing import *

_segmentnames=oneOf(finsegments.segments.keys())
_lhs=Word(alphas)
_op=oneOf(u'= < > == <= >= !=')
_rhs=(
  (Word(alphanums) + Optional(quotedString)) | 
  quotedString
).setParseAction(lambda x: u''.join(x))
_exprs=ZeroOrMore(Group(_lhs + _op + _rhs))
_bnf=_segmentnames + _exprs + (LineEnd() | StringEnd())

#print _bnf

def finParseFile(f):
  """Parses the file-like object passed to it. The object must support
  iteration and return a line to be parsed per iteration."""
  curmod=None
  for line in f:
    try:
#      print
#      print 'Line:', repr(line)
      r=_bnf.parseString(line)
#      print 'Found:', r
#      print 'Keyword:', r[0]
#      print 'Args:', r[1:]
      curmod=finsegments.segments[r[0]](curmod)
      curmod.parse(r[1:])
#      print 'Segargs:', curmod._args
    except ParseException, e:
      print e.msg
      print e.markInputline()
  curmod.run()