import finconfig
import fincoretypes
import fincoredates
import fincorenumbers
import fincorestrings
import fincoresegment
import os
import os.path
import finsegments

class finFileFindSegment(fincoresegment.finSegment):
  arguments={
    'name': fincorestrings.finStringMatcher,
    'age': fincoredates.finDateRelationMatcher,
    'depth': fincorenumbers.finIntegerRelationMatcher
  }
  mandatoryarguments={
    'path': fincorestrings.finArgument
  }
  input=[]
  output=[fincoretypes.finFileSequence]
  keyword='findfiles'
  
  def __iter__(self):
    q=[(1, self._args['path'], x) for x in os.listdir(self._args['path'])] + \
      [(0, self._args['path'], '.')]
#    print 'q:', q
    while True:
      current=q.pop()
#      if 'depth' in self._args:
#        if not self._args['depth'].match(current[0]):
#          continue
#      print 'Current:', current
      pathname=os.path.join(*current[1:3])
      s=os.stat(pathname)
#      print "File: %s, %r" % (pathname, s)
      if 'age' in self._args:
        if not self._args['age'].match(s[8]):
          continue
      if 'name' in self._args:
        if self._args['name'].match(current[2]):
#          yield (pathname, None)
          yield pathname
      if os.path.isdir(pathname):
        if 'depth' in self._args:
          if not self._args['depth'].match(current[0]+1):
            continue
        q[0:0]=[(current[0]+1, pathname, x) for x in os.listdir(pathname)]

finsegments.finRegisterSegment(finFileFindSegment)